from random import randint as rand, shuffle

def strmodify(s, i, ch):
    return s[:i] + ch + s[(i+1):]


h, w = rand(4, 10), rand(4, 10)

def gen(tc, w, h, max_x):
    print("TC= {}\n".format(tc))
    fin = open('{}.in'.format(tc), 'w')
    fout = open('{}.out'.format(tc), 'w')

    print(w, h)
    fin.write("{} {}\n".format(w, h))
    g = ['#' * w]
    for r in range(h-2):
        g.append('#'+('.'*(w-2))+'#')
    g.append('#' * w)

    rr = [x for x in range(1, h-1)]
    shuffle(rr)
    g[rr[0]] = strmodify(g[rr[0]], rand(1, w-2), 'S')
    # g[h//2] = strmodify(g[h//2], w//2, 'S')

    bound = [(0, rand(1, w-1)), (rand(1, h-1), 0)]
    ey, ex = bound[0] if rand(0, 1) == 0 else bound[1]
    while ey == ex or (ey == 0 and ex == w-1) or (ex == 0 and ey == h-1):
        bound = [(0, rand(1, w-1)), (rand(1, h-1), 0)]
        ey, ex = bound[0] if rand(0, 1) == 0 else bound[1]
    g[ey] = strmodify(g[ey], ex, 'E')
    
    for i in range(1, h-1):
        for j in range(1, w-1):
            if g[i][j] == '.' and rand(0, h * w) < (h * w // 1.5):
                g[i] = strmodify(g[i], j, '#')

    x_count = 0
    while x_count < max_x:
        for i in range(1, h-1):
            for j in range(1, w-1):
                if g[i][j] != '.' or rand(0, h * w) >= 1:
                    continue
                g[i] = strmodify(g[i], j, 'X')
                x_count += 1
                if x_count >= max_x:
                    break
            if x_count >= max_x:
                break

    grid = str("\n".join(g)+"\n")
    print(grid)
    fin.write(grid)

    fin.close()
    fout.close()


gen(1, 50, 5, 1)
